let isTyping = false; // Global flag to indicate if typing is in progress
let replacements = []; // initilazilemeekmsmanehbuekvfty

// replace names in text
function replaceTextInElement(element) {
  // Skip replacements if the element is an input, textarea, or contenteditable
  if (element.tagName === 'INPUT' || element.tagName === 'TEXTAREA' || element.hasAttribute('contenteditable')) {
    return;
  }

  const walker = document.createTreeWalker(
    element,
    NodeFilter.SHOW_TEXT,
    null,
    false
  );

  let node;
  while ((node = walker.nextNode())) {
    // dont do the usernames
    if (!node.nodeValue.trim().startsWith('@')) {
      replacements.forEach(({ oldName, newName }) => {
        const regex = new RegExp(`\\b${oldName}\\b`, 'gi'); // word boundary for exact matches
        if (regex.test(node.nodeValue)) {
          node.nodeValue = node.nodeValue.replace(regex, newName);
        }
      });
    }
  }
}

// Function to apply the name replacements across like,,,, shit like the display name
function applyReplacements() {
  const targetSelectors = [
    'span:not([contenteditable])',
    '.css-901oao:not([contenteditable])',
    'div[role="link"]:not([contenteditable])',
    'a:not([contenteditable])',
    'div[aria-label]:not([contenteditable])'
  ];

  targetSelectors.forEach(selector => {
    document.querySelectorAll(selector).forEach(element => {
      replaceTextInElement(element);
    });
  });
}

// god FUCKING KILL ME DUDE THIS WONT FUCKING WORK WHY CANT I MAKE THIS WORK WHY WHY WHY
// maybe its looking for the tweet composition box on load when its not there ?? idfk ?????
// yet again the gfalg I SOIUSPSOE DOT BE FUCIKUNGI SET
// handle input areas specifically for the compo. box
function handleTextInputAreas() {
  const tweetInput = document.querySelector('[data-testid="tweetTextarea_0"]');

  if (tweetInput) {
    tweetInput.addEventListener('focus', () => {
      isTyping = true; // set typing flag when focused
    });

    tweetInput.addEventListener('blur', () => {
      isTyping = false; // clear typing flag when blurred
      applyReplacements(); // reapply replacements after typing is done
    });
  } else {
    console.warn("Tweet input area not found. Retrying...");
    setTimeout(handleTextInputAreas, 500); // Retry after a short delay
  }
}

// set up a MO to detect changes in the DOM
function observeDOMChanges() {
  const observer = new MutationObserver(() => {
    // check if typing is in progress; skip replacements if so
    if (!isTyping) {
      applyReplacements(); // Reapply the replacements whenever the page / dom,,, changes
    }
  });

  observer.observe(document.body, {
    childList: true,
    subtree: true,
    characterData: true
  });

  handleTextInputAreas(); // setup
}

// Initialize the script
function initializeScript() {
  chrome.storage.local.get(['replacements'], ({ replacements: storedReplacements }) => {
    if (storedReplacements && storedReplacements.length > 0) {
      replacements = storedReplacements; // assign global replacements
      applyReplacements(); // apply initial replacements
      observeDOMChanges(); // set up the observer
    }
  });
}

// ....its obvious
initializeScript();
